=== casd-wrap/CMakeLists.txt ===
FILE(GLOB SRCS *.cpp)

add_executable(buildbox-casd-wrap ${SRCS})
target_precompile_headers(buildbox-casd-wrap REUSE_FROM common)
target_link_libraries(buildbox-casd-wrap common)

install(TARGETS buildbox-casd-wrap RUNTIME DESTINATION bin)
