=== casdownload/CMakeLists.txt ===
add_executable(casdownload casdownload.m.cpp processargs.cpp)
target_precompile_headers(casdownload REUSE_FROM common)
target_include_directories(casdownload PRIVATE ".")
target_link_libraries(casdownload common)
install(TARGETS casdownload RUNTIME DESTINATION bin COMPONENT casdownload)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()
