=== casupload-oci/CMakeLists.txt ===
add_executable(casupload-oci casupload-oci.m.cpp processargs.h processargs.cpp)
target_precompile_headers(casupload-oci REUSE_FROM common)
target_include_directories(casupload-oci PRIVATE ".")
target_link_libraries(casupload-oci common)
install(TARGETS casupload-oci RUNTIME DESTINATION bin COMPONENT casupload-oci)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()
