=== casupload/CMakeLists.txt ===
add_executable(casupload casupload.m.cpp processargs.h processargs.cpp)
target_precompile_headers(casupload REUSE_FROM common)
target_include_directories(casupload PRIVATE ".")
target_link_libraries(casupload common)
install(TARGETS casupload RUNTIME DESTINATION bin COMPONENT casupload)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()
