=== commonmetrics/CMakeLists.txt ===
file(GLOB SRCS "*.cpp")

add_library(commonmetrics STATIC ${SRCS})

target_compile_features(commonmetrics PUBLIC cxx_std_20)

include(CTest)
if(BUILD_TESTING)
    add_subdirectory(test)
endif()
