=== logstreamreceiver/CMakeLists.txt ===
add_executable(logstreamreceiver logstreamreceiver.m.cpp bytestreamservicer.cpp)
target_precompile_headers(logstreamreceiver REUSE_FROM common)
target_include_directories(logstreamreceiver PRIVATE ".")
target_link_libraries(logstreamreceiver common)
install(TARGETS logstreamreceiver RUNTIME DESTINATION bin COMPONENT logstreamreceiver)
