=== debian/changelog ===
buildbox (1.3.53-1) unstable; urgency=low

  * Initial release. Closes: #1127157

 -- Theodore Tucker <theodore@tti0.net>  Tue, 17 Feb 2026 15:32:46 +0000
