=== debian/control ===
Source: buildbox
Section: devel
Priority: optional
Maintainer: Theodore Tucker <theodore@tti0.net>
Build-Depends:
 bubblewrap,
 cmake,
 debhelper-compat (= 13),
 help2man,
 libcurl4-openssl-dev,
 libfuse3-dev,
 libgmock-dev,
 libgoogle-glog-dev,
 libgrpc-dev,
 libgrpc++-dev,
 libprotobuf-dev,
 libssl-dev,
 libtomlplusplus-dev,
 nlohmann-json3-dev,
 pkgconf,
 protobuf-compiler-grpc,
 uuid-dev
Standards-Version: 4.7.3
Homepage: https://buildgrid.gitlab.io/buildbox/buildbox/index.html
Vcs-Git: https://salsa.debian.org/tti0/buildbox.git
Vcs-Browser: https://salsa.debian.org/tti0/buildbox

Package: buildbox
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 bubblewrap,
 fuse3
Description: suite of tools for remote build execution
 A suite of clients for remote build execution, conforming to
 the Remote Execution API and the Remote Workers API.
 Includes buildbox-casd, buildbox-fuse, buildbox-run,
 recc and trexe, amongst others.
