=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1
export DEB_CMAKE_ARGS = \
	-DBUILD_TESTING=OFF \
	-DCASD_BUILD_BENCHMARK=OFF \
	-DRUN_USERCHROOT=OFF

export DEB_BUILDBOX_BINARIES = \
	buildbox-casd-wrap \
	buildbox-casd \
	buildbox-fuse \
	buildbox-run-bubblewrap \
	buildbox-run-hosttools \
	buildbox-run-oci \
	buildbox-run \
	buildbox-worker \
	casdownload \
	casupload-oci \
	casupload \
	logstreamreceiver \
	logstreamtail \
	outputstreamer \
	recc \
	rexplorer \
	rumbad \
	trexe

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)" $(DEB_CMAKE_ARGS)

execute_after_dh_auto_install:
#	Generate man pages
	for binary in $(DEB_BUILDBOX_BINARIES); do \
		help2man \
		--name=$$binary \
		--no-info \
		--no-discard-stderr \
		--output debian/$$binary.1 \
		debian/buildbox/usr/bin/$$binary ; \
	done
